# Leon3 PSL Usecase #

A dual-core LEON3 system with assertions for the following hardware components:

* I2C Bus

* AMBA AHB Arbiter, Master

* Application (LEDs,...)

* UART

* Timer

## Setup ##

The directory `/grlib-gpl-1.3.1-b4135/designs/leon3mp-altera-cycv-soc-5CSXFC6D6F31C8ES` contains the design files, scripts, PSL files, etc. for the use case

The directory `/grlib-gpl-1.3.1-b4135/boards/leon3mp-altera-cycv-soc-5CSXFC6D6F31C8ES` contains board-specific design files, constraints, etc.

## Assertions ##

PSL properties can be found in `/grlib-gpl-1.3.1-b4135/designs/leon3mp-altera-cycv-soc-5CSXFC6D6F31C8ES/psl`.

`leon3mp.psl` is the central PSL file that contains assertions for AMBA, UART, LED, Timer, I2C...

## Prerequisites ##

* GNU Make

* QuestaSim

## Getting Started ##

* `cd` into `/grlib-gpl-1.3.1-b4135/designs/leon3mp-altera-cycv-soc-5CSXFC6D6F31C8ES`

* execute `make scripts`

* execute `make pslsim`

* execute `make pslsim-launch`

* Add some assertions to the wave viewer. E.g., use:

    add wave /testbench/d3/assert__only_one_master_granted /testbench/d3/assert__rule5_addr_stable_during_transition /testbench/d3/assert__address_translation /testbench/d3/assert__generate_psel /testbench/d3/assert__generate_penable /testbench/d3/assert__A1 /testbench/d3/assert__A5 /testbench/d3/assert__A7_1 /testbench/d3/assert__A7_2 /testbench/d3/assert__A7_3 /testbench/d3/assert__A7_4 /testbench/d3/assert__G2 /testbench/d3/assert__G3 /testbench/d3/assert__A1__1 /testbench/d3/assert__A5__1 /testbench/d3/assert__A7_1__1 /testbench/d3/assert__A7_2__1 /testbench/d3/assert__A7_3__1 /testbench/d3/assert__A7_4__1 /testbench/d3/assert__G2__1 /testbench/d3/assert__G3__1 /testbench/d3/assert__rule1_never_idle_after_busy /testbench/d3/assert__rule2_busy_only_in_last_cycle_of_INCR /testbench/d3/assert__rule3_next_addr_control_during_busy /testbench/d3/assert__rule5_hsize_never_larger_bus_width /testbench/d3/assert__rule6a_haddr_increment_incr /testbench/d3/assert__rule6b_haddr_increment_wrap4 /testbench/d3/assert__rule6c_haddr_increment_wrap8 /testbench/d3/assert__rule6d_haddr_increment_wrap16 /testbench/d3/assert__rule7_addr_control_change_during_hready_low /testbench/d3/assert__rule8_addr_control_stable_during_busy /testbench/d3/assert__rule9a_control_stable_during_sequential /testbench/d3/assert__rule12_reattempt_after_retry /testbench/d3/assert__rule13_reattempt_after_split /testbench/d3/assert__rule15_hwdata_stable_during_busy /testbench/d3/assert__rule16_bursts_dont_cross_1kb /testbench/d3/assert__rule19_hlock_during_burst /testbench/d3/assert__rule21_htrans_idle_after_reset /testbench/d3/assert__rule22_htrans_change_when_hready_low /testbench/d3/assert__scl_liveness /testbench/d3/assert__i2c_start_cond /testbench/d3/assert__i2c_stop_cond /testbench/d3/assert__uart_obeys_ctsn /testbench/d3/assert__first_interrupt /testbench/d3/assert__timer_interrupt_never_cpu0 /testbench/d3/assert__subsequent_interrupts /testbench/d3/assert__gpio_onehot

* Run for a few milliseconds
