library ieee;
use ieee.std_logic_1164.all;
library grlib;
use grlib.config_types.all;
use grlib.config.all;
use grlib.amba.all;
use grlib.stdlib.all;
use grlib.devices.all;
library techmap;
use techmap.gencomp.all;

package mypackage is

component ahbrom
  generic (
    hindex  : integer := 0;
    haddr   : integer := 0;
    hmask   : integer := 16#fff#;
    pipe    : integer := 0;
    tech    : integer := 0;
    kbytes  : integer := 1);
  port (
    rst     : in  std_ulogic;
    clk     : in  std_ulogic;
    ahbsi   : in  ahb_slv_in_type;
    ahbso   : out ahb_slv_out_type
  );
end component;

component r6_addr_incr_check_2reg is
    port (
        clk: in std_logic;
        res_n: in std_logic;
        
        htrans_i : in std_logic_vector(1 downto 0);
        hburst_i : in std_logic_vector(2 downto 0);
        
        haddr_i  : in std_logic_vector(31 downto 0);
        hsize_i  : in std_logic_vector(2 downto 0);
        
        res_o    : out std_logic
    );
end component;

component r6_addr_incr_check_1reg is
    port (
        clk: in std_logic;
        res_n: in std_logic;
        
        htrans_i : in std_logic_vector(1 downto 0);
        hburst_i : in std_logic_vector(2 downto 0);
        
        haddr_i  : in std_logic_vector(31 downto 0);
        hsize_i  : in std_logic_vector(2 downto 0);
        
        res_o    : out std_logic
    );
end component;

--component my_ahbram
-- generic (
--    hindex  : integer := 0;
--    haddr   : integer := 0;
--    hmask   : integer := 16#fff#;
--    tech    : integer := DEFMEMTECH; 
--    kbytes  : integer := 1;
--    pipe    : integer := 0;
--    maccsz  : integer := AHBDW); 
--  port (
--    rst     : in  std_ulogic;
--    clk     : in  std_ulogic;
--    ahbsi   : in  ahb_slv_in_type;
--    ahbso   : out ahb_slv_out_type
--  );
--end component;

--inside my_ahbram
--component alt_ram
--	PORT
--	(
--		address		: IN STD_LOGIC_VECTOR (9 DOWNTO 0);
--		byteena		: IN STD_LOGIC_VECTOR (3 DOWNTO 0) :=  (OTHERS => '1');
--		clock		: IN STD_LOGIC  := '1';
--		data		: IN STD_LOGIC_VECTOR (31 DOWNTO 0);
--		wren		: IN STD_LOGIC ;
--		q		: OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
--	);
--END component;


end;
