-- LEON3 Usecase JRZ VECS - FH Technikum Wien (c) 2013/2014

library IEEE;
	use IEEE.std_logic_1164.all;
package ahb_constants_p is
	
	
	-- AHB HTRANS values 
	-- from AMBA 2.0 Spec, ARM IHI 0011A; Table 3-1 "Transfer type encoding"
	constant AHB_HTRANS_IDLE    : std_logic_vector(1 downto 0) :=  "00";
	constant AHB_HTRANS_BUSY    : std_logic_vector(1 downto 0) :=  "01";
	constant AHB_HTRANS_NONSEQ  : std_logic_vector(1 downto 0) :=  "10";
	constant AHB_HTRANS_SEQ     : std_logic_vector(1 downto 0) :=  "11";
	
	-- AHB HBURST values 
	-- from AMBA 2.0 Spec, ARM IHI 0011A; Table 3-2 "Burst signal encoding"
	constant AHB_HBURST_SINGLE  : std_logic_vector(2 downto 0) := "000";
	constant AHB_HBURST_INCR    : std_logic_vector(2 downto 0) := "001";
	constant AHB_HBURST_WRAP4   : std_logic_vector(2 downto 0) := "010";
	constant AHB_HBURST_INCR4   : std_logic_vector(2 downto 0) := "011";
	constant AHB_HBURST_WRAP8   : std_logic_vector(2 downto 0) := "100";
	constant AHB_HBURST_INCR8   : std_logic_vector(2 downto 0) := "101";
	constant AHB_HBURST_WRAP16  : std_logic_vector(2 downto 0) := "110";
	constant AHB_HBURST_INCR16  : std_logic_vector(2 downto 0) := "111";

	-- AHB HRESP values 
	-- from AMBA 2.0 Spec, ARM IHI 0011A; Table 3-5 "Response encoding"	
	constant AHB_HRESP_OKAY     : std_logic_vector(1 downto 0) :=  "00";
	constant AHB_HRESP_ERROR    : std_logic_vector(1 downto 0) :=  "01";
	constant AHB_HRESP_RETRY    : std_logic_vector(1 downto 0) :=  "10";
	constant AHB_HRESP_SPLIT    : std_logic_vector(1 downto 0) :=  "11";
	
end package ahb_constants_p;