library ieee;
    use ieee.std_logic_1164.all;
    use ieee.numeric_std.all;

entity r6_addr_incr_check_1reg is
    port (
        clk: in std_logic;
        res_n: in std_logic;
        
        htrans_i : in std_logic_vector(1 downto 0);
        hburst_i : in std_logic_vector(2 downto 0);
        
        haddr_i  : in std_logic_vector(31 downto 0);
        hsize_i  : in std_logic_vector(2 downto 0);
        
        res_o    : out std_logic
        
    );
end entity r6_addr_incr_check_1reg;

architecture rtl of r6_addr_incr_check_1reg is

    signal s_htrans_reg_0 : std_logic_vector(1 downto 0);
    
    signal s_haddr_reg_0  : std_logic_vector(31 downto 0);
    
    signal s_hsize_reg_0  : std_logic_vector(2 downto 0);
    
    signal s_hburst_reg_0 : std_logic_vector(2 downto 0);

begin

--                         always((ahbmo(0).htrans /= AHB_HTRANS_NONSEQ and 
--                             prev(ahbmo(0).htrans) /= AHB_HTRANS_BUSY 
--                            and ( ahbmo(0).hburst = AHB_HBURST_INCR  or
--                                  ahbmo(0).hburst = AHB_HBURST_INCR4 or
--                                  ahbmo(0).hburst = AHB_HBURST_INCR8 or
--                                  ahbmo(0).hburst = AHB_HBURST_INCR16
--                            )) -> (                        
--                              to_integer(unsigned(ahbmo(0).haddr)) = (
--                              to_integer(unsigned(prev(ahbmo(0).haddr))) +
--                              2**(to_integer(unsigned(prev(ahbmo(0).hsize))+3)))
--                          ));


	p_test : process (clk, res_n)
	begin
		if res_n = '0' then
		    s_htrans_reg_0 <= (others => '0');
			s_haddr_reg_0  <= (others => '0');
			s_hsize_reg_0  <= (others => '0');
			s_hburst_reg_0 <= (others => '0');
			
			res_o <= '0';
			
		elsif rising_edge(clk) then
		    
		    s_htrans_reg_0 <= htrans_i;
		    s_haddr_reg_0  <= haddr_i;
		    s_hsize_reg_0  <= hsize_i;
		    s_hburst_reg_0 <= hburst_i;

		    res_o        <= '0';
		    
		    if( s_htrans_reg_0 /= "01" and htrans_i /= "10" and (
		        hburst_i = "001" or hburst_i ="011" or hburst_i = "101" or hburst_i = "111")) then
		        
		        if(to_integer(unsigned(haddr_i)) = to_integer(unsigned(s_haddr_reg_0)) + 2**(to_integer(unsigned(s_hsize_reg_0)+3))) then
		            res_o <= '1';
		        end if;
		        
		    end if;
		    
			
		end if;
	end process p_test;
	

end rtl;
