/**
 * assertion_collector.c 
 * 
 * Created on: Oct. 29, 2013
 * Adapted for Leon3: Nov. 19, 2013
 * Added Leon3 specific assertion collector: 14.2.2014
 *     Author: Christian(8051); Matthias(Leon3)
 */
#include "inc_usecase_rtc/includes.h"

/*TODO: optimization - have a single place to store these pointers*/
volatile ASS_COLL_t *ass_coll_dev = (ASS_COLL_t*) ASS_COLLECTOR_BASE_ADDR; 
volatile GPIO_t *gpio0asscoll_dev = (GPIO_t *)GPIO0_BASE_ADDR;
volatile I2C_SLV_t *i2c_lcd_asscol_slv = (I2C_SLV_t *) LCD_BASE_ADDR;

#define ASSERTIONS (8)

static uint8_t assertion_ids[ASSERTIONS] =  {
	RULE5_SAFETY_ASSERTION,
	TIMER_IRQ_ASSIGNED_CPU1,
	TIMER_IRQ_SUCCESSIVE_CPU1,
	I2C_LIVENESS,
	UART_OBEYS_CTSN,
	RULE22_HTRANS_CHANGE_WHEN_HREADY_LOW_CPU_0,
	RULE22_HTRANS_CHANGE_WHEN_HREADY_LOW_CPU_1,
	RULE5_ADDR_STABLE_DURING_TRANSITION
};

void assertion_checker_isr_function (uint32_t id) {


	register uint32_t reg;
	uint8_t i;
	reg = ass_coll_dev->pend;

	
	/*display fireing assertions*/
	for(i = 0; i< ASSERTIONS; i++) {

		gpio0asscoll_dev->output &= ~(1<<i);
		if(reg & assertion_ids[i]) {
			gpio0asscoll_dev->output |= (1<<i);
		}
	}
	/*just acknowledge interrupts*/
	ass_coll_dev->pend = reg;
	
	
}


void enable_assertion_capture(uint32_t mask, uint32_t fatal_mask) {

	/*assure gpio0 pins 0 to 9 to output*/
	gpio0asscoll_dev->dir |= 0x3FF;
	
	/*init assertion collector*/
	ass_coll_dev->cfg = 0;/*reset*/
	ass_coll_dev->pend = ~(0x00);/*ack all possible pendings*/
	register_isr(11/*assertion capture slot*/,assertion_checker_isr_function);
	ass_coll_dev->cfg = mask;
	ass_coll_dev->coll = fatal_mask;/*if corresponding assertion fails (determined by mask), then the whole system resets itself*/
	activate_interrupt(0, 11/*assertion capture slot*/);/*on cpu 0*/

	
}
