/**
 * assertion_collector.h
 *
 * Created on: Oct. 29, 2013
 *	Added Leon3 specific assertion collector: 14.2.2014
 *     Author:  Christian(8051),Matthias (Leon3)
 */

#ifndef _ASSERTION_COLLECTOR_H_
#define _ASSERTION_COLLECTOR_H_

/*****************************************************************************
 * F U N C T I O N   P R O T O T Y P E S                                     *
 *****************************************************************************/

#define ASS_COLLECTOR_BASE_ADDR ((uint32_t *)0x80000B00)

/*assertion masks*/
#define DISABLE_ALL (0)
#define RULE5_SAFETY_ASSERTION (1<<0)
#define TIMER_IRQ_ASSIGNED_CPU1 (1<<1)
#define TIMER_IRQ_SUCCESSIVE_CPU1 (1<<2)
#define I2C_LIVENESS (1<<3)
#define UART_OBEYS_CTSN (1<<4)
#define RULE22_HTRANS_CHANGE_WHEN_HREADY_LOW_CPU_0 (1<<5)
#define RULE22_HTRANS_CHANGE_WHEN_HREADY_LOW_CPU_1 (1<<6)
#define RULE5_ADDR_STABLE_DURING_TRANSITION (1<<7)

/*fatal masks*/
#define FATAL_RULE5_SAFETY_ASSERTION (RULE5_SAFETY_ASSERTION)
#define FATAL_TIMER_IRQ_ASSIGNED_CPU1 (TIMER_IRQ_ASSIGNED_CPU1)
#define FATAL_TIMER_IRQ_SUCCESSIVE_CPU1 (TIMER_IRQ_SUCCESSIVE_CPU1)
#define FATAL_I2C_LIVENESS (I2C_LIVENESS)
#define FATAL_UART_OBEYS_CTSN (UART_OBEYS_CTSN)
#define FATAL_RULE22_HTRANS_CHANGE_WHEN_HREADY_LOW_CPU_0 (RULE22_HTRANS_CHANGE_WHEN_HREADY_LOW_CPU_0)
#define FATAL_RULE22_HTRANS_CHANGE_WHEN_HREADY_LOW_CPU_1 (RULE22_HTRANS_CHANGE_WHEN_HREADY_LOW_CPU_1)
#define FATAL_RULE5_ADDR_STABLE_DURING_TRANSITION (RULE5_ADDR_STABLE_DURING_TRANSITION)

typedef struct {
	uint32_t coll;/*fatal indicator: if corresponding assertion fails (determined by mask), then the whole system resets itself*/
	uint32_t cfg;/*whether this assertion is able to trigger an interrupt (1 -> YES, = -> NO)*/
	uint32_t pend;/*which assertions have failed and are thus pending (write '1' to corresponding bit position to clear)*/
} ASS_COLL_t;


void enable_assertion_capture(uint32_t, uint32_t);
unsigned char read_assertion_status(void);

#endif /* _ASSERTION_COLLECTOR_H_ */
