/**
 * lcd.h 
 * 
 * Created on: Oct. 28, 2013
 *     Author: Christian, Matthias 
 * Adapted to new driver architecture
 */

#include <stdint.h>

#ifndef _LCD_H_
#define _LCD_H_

/*****************************************************************************
 * S Y M B O L I C   C O N S T A N T S                                       *
 *****************************************************************************/

#define DISPLAY_I2C_ADDR 0x28

#define DISPLAY_CMD      0xFE

#define DISPLAY_CMD_DISPLAY_ON    0x41
#define DISPLAY_CMD_CLEAR_SCREEN  0x51
#define DISPLAY_CMD_SET_CURSOR    0x45

#define LINE_1           0x00
#define LINE_2           0x40

/*****************************************************************************
 * F U N C T I O N   P R O T O T Y P E S                                     *
 *****************************************************************************/

void init_display(I2C_SLV_t *i2c_lcd_slv);
void display_puts(I2C_SLV_t *i2c_lcd_slv,char const * string, uint8_t line);
void delay_100us(uint32_t m);
void display_putc(I2C_SLV_t *i2c_lcd_slv, char c);

#endif /* _LCD_H_ */
