/**
 * rtc.h 
 * 
 * Created on: Oct. 24, 2013
 *     Author: Christian
 */
 
#include <stdint.h>
 
#ifndef _RTC_H_
#define _RTC_H_

/*****************************************************************************
 * S Y M B O L I C   C O N S T A N T S                                       *
 *****************************************************************************/

#define RTC_I2C_ADDRESS 0x68

#define RTC_SECONDS_REG (0x00)
#define RTC_MINUTES_REG (0x01)
#define RTC_HOURS_REG   (0x02)
#define RTC_DOW_REG     (0x03)
#define RTC_DOM_REG     (0x04)
#define RTC_MONTH_REG   (0x05)
#define RTC_YEAR_REG    (0x06)

#define RTC_CTRL_REG    (0x0E)
#define RTC_STATUS_REG  (0x0F)

#define DEC2BCD(x) (((((uint8_t)x)/10) << 4) | ((uint8_t)x - ((((uint8_t)x)/10)*10))) 

/*****************************************************************************
 * T Y P E   D E F I N I T I O N S                                           *
 *****************************************************************************/

struct time {
	uint8_t sec;
	uint8_t min;
	uint8_t hrs;
	uint8_t dow;
	uint8_t dom; 
	uint8_t month;
	uint8_t year;
};

/*****************************************************************************
 * F U N C T I O N   P R O T O T Y P E S                                     *
 *****************************************************************************/

char init_rtc(I2C_SLV_t *i2c_rtc_slv,struct time * set_time);
char read_rtc(I2C_SLV_t *i2c_rtc_slv,struct time * read_time);

#endif
