/**
 * irq.h 
 * 
 * Created on: Oct. 24, 2013
 *     Author: Matthias
 * 
 */


#ifndef IRQ_H
#define IRQ_H


/*interrupt controller*/

#define CPUS 2

#define IRQMP0_BASE_ADDR ((uint32_t *)0x80000200)

typedef struct {
uint32_t level;
uint32_t pending;
uint32_t force0;
uint32_t clear;
uint32_t mpstat;
uint32_t broadcast;  
} IRQMP_BASE_t;

#define IRQMP0_MASK_ADDR ((uint32_t *)(0x80000200+0x40))

typedef struct {
uint32_t mask[CPUS];
} IRQMP_MASK_t;

#define IRQMP0_FORCE_ADDR ((uint32_t *)(0x80000200+0x80))

typedef struct {
uint32_t force[CPUS];
} IRQMP_FORCE_t;

#define IRQMP0_EXTACK_ADDR ((uint32_t *)(0x80000200+0xC0))

typedef struct {
uint32_t extack[CPUS];
} IRQMP_EXTACK_t;


typedef void (*isr_i)(uint32_t);

uint32_t get_cpuid(void);

void _irq_handle(uint32_t id);

void init_irqmp(void);

void register_isr(uint32_t id,void (*isr)(uint32_t));

void activate_interrupt(uint32_t cpuid, uint32_t id);

void start_cpu(uint32_t cpu);

void register_cpu(uint32_t id);

#endif /*IRQ_H*/