/**
 * led.c
 *
 * Created on: Oct. 24, 2013
 *     Author: Christian
 * Changed LEDR has its own gpio port now, Matthias
 */

#include "inc_usecase_rtc/includes.h"


extern volatile GPIO_t *gpio0_dev;
extern volatile GPIO_t *gpio1_dev;

void display_seconds(uint8_t seconds){

	uint32_t leds;

	leds = (1 << ((uint32_t)seconds & 0xF));

	gpio1_dev->output &= ~((LED_MASK_10) << LEDR_OFFSET);       /* Set all red LEDs to 0 */
	gpio1_dev->output |=  (leds << LEDR_OFFSET);                /* Set red LEDs          */

}


void flash_leds(uint8_t led_color) {

	uint32_t i, offset;

	if(led_color == GREEN_LEDS) {
		offset = LEDG_OFFSET;
	} else if (led_color == RED_LEDS) {
		offset = LEDR_OFFSET;
	}

	gpio1_dev->output &= ~(LED_MASK_09 << offset);
	gpio1_dev->output |=  (LED_MASK_L5 << offset);

	for(i = 0; i < FLASH_DURATION_OUTER; i++) delay_100us(FLASH_DURATION_INNER);

	gpio1_dev->output &= ~(LED_MASK_09 << offset);
	gpio1_dev->output |=  (LED_MASK_U5 << offset);

	for(i = 0; i < FLASH_DURATION_OUTER; i++) delay_100us(FLASH_DURATION_INNER);
}
