        .section   .text
        .proc   0
        .align  4
        .global start
        .global __edata
        .global __end
        .global _trap_table
        .global _startup
 !clears bss and calls main function
/*
!SPARCv8 barebone trap table
  .section .text
  .align 4096 !optimized - is located ta the first 4k now, moreover a reset trap event causes startup code to run
  .global _trap_table
*/

start:
_trap_table:
set  _startup, %g1 !
jmp  %g1 ! jup to startup code
nop

!ta 0 !instr access execption
mov  1, %l7
rd  %psr, %l0
ba  _panic_entry /*_panic_entry is merley used fro trap handler debugging*/
rd  %wim, %l3


ta  0 !illegal instr
nop
nop
nop

ta  0 !priv instr
nop
nop 
nop

ta 0 !fp disabled
nop
nop
nop


rd  %psr, %l0 !window overlflow
set _window_overflow, %g1 !takes two asm instructions
jmp  %g1


rd  %psr, %l0 !window underflow
set _window_underflow, %g1 !takes two asm instructions
jmp  %g1


!ta  0 !mem_not_aligned
mov  8, %l7
rd  %psr, %l0
ba  _panic_entry
rd  %wim, %l3

ta  0 !fp exception
nop
nop
nop

!ta 0 !data access exception
mov  0x10, %l7
rd  %psr, %l0
ba  _panic_entry
rd  %wim, %l3

ta  0 !tag overflow
nop 
nop 
nop 

ta  0 !watchpoint detected
nop
nop
nop

ta  0 !0xC
nop 
nop 
nop 

ta  0 !0xD
nop 
nop 
nop 

ta  0 !0xE
nop 
nop 
nop 

ta  0 !0xF
nop 
nop 
nop 

ta  0 !0x10
nop 
nop 
nop 

mov  1, %l7	! 1 
rd  %psr, %l0 !save psr
ba _irq_entry !branch takes 22 immed. as target address => sufficient
rd  %wim, %l3 !executed in delay slot. save wim

mov  2, %l7
rd  %psr, %l0
ba  _irq_entry
rd  %wim, %l3

mov  3, %l7
rd  %psr, %l0
ba  _irq_entry
rd  %wim, %l3

mov  4, %l7
rd  %psr, %l0
ba  _irq_entry
rd  %wim, %l3

mov  5, %l7
rd  %psr, %l0
ba  _irq_entry
rd  %wim, %l3

mov  6, %l7
rd  %psr, %l0
ba  _irq_entry
rd  %wim, %l3

mov  7, %l7
rd  %psr, %l0
ba  _irq_entry
rd  %wim, %l3

mov  8, %l7
rd  %psr, %l0
ba  _irq_entry
rd  %wim, %l3

mov  9, %l7
rd  %psr, %l0
ba  _irq_entry
rd  %wim, %l3

mov  0xa, %l7
rd  %psr, %l0
ba  _irq_entry
rd  %wim, %l3

mov  0xb, %l7
rd  %psr, %l0
ba  _irq_entry
rd  %wim, %l3

mov  0xc, %l7
rd  %psr, %l0
ba  _irq_entry
rd  %wim, %l3

mov  0xd, %l7
rd  %psr, %l0
ba  _irq_entry
rd  %wim, %l3

mov  0xe, %l7
rd  %psr, %l0
ba  _irq_entry
rd  %wim, %l3

mov  0xf, %l7
rd  %psr, %l0
ba  _irq_entry
rd  %wim, %l3        
        
!end trap table does not support extended interrupts!  
                    
         
_startup:
  set _trap_table, %g1
  mov %g1, %tbr		!setup trap table
! save  %sp, -64, %sp !function prologue
  subcc %g4, 0, %g0 ! !test cpuid to be zero -> if yes clear bss and copy data, if not just branch to main
  bne 1f
  nop
  set __edata, %g2
  set __end, %g3
  mov  %g0, %g1
  sub  %g3, %g2, %g3
zerobss:
  subcc  %g3, 8, %g3
  bge,a  zerobss
  std  %g0, [ %g2 + %g3 ]
  set __end, %o0
1:
  clr %o0
  call main
  nop
! jmpl %i7 + 8, %g0 !ignore function return value
! restore %g0, 0, %g0

loop:
  b loop

  .section .text
  .align 4
  .global _panic
  
_panic_entry:
#ifdef DEBUG_TRAP_TABLE
  call _panic
  mov %l7, %o0
  mov %l0, %psr
#else
	nop
#endif
  nop
  nop
  nop
  nop
  jmp %l1 ! return from irq
  rett %l2
  
  !tell assembler that _panic_entry is a function
  .type _panic_entry,#function
  .size _panic_entry,.-_panic_entry
  
  
  
  
  .section .text
  .align 4
  .global _irq_handle

/*call irq handler, it will call the right ISR*/
_irq_entry:
  call _irq_handle
  mov %l7, %o0 !%o => first input parameter to function, use delay slot
  mov %l0, %psr
  nop
  nop
  nop
  nop
  jmp %l1 ! return from irq
  rett %l2
  
  !tell assembler that _irq_entry is a function
  .type _irq_entry,#function
  .size _irq_entry,.-_irq_entry
  
 /* a SAVE instruction caused a trap; thank you http://www.sics.se/~psm/sparcstack.html*/
_window_overflow:

        
        /* rotate WIM on bit right, we have 8 windows, THIS IS TRUE FOR US */
        mov %wim,%l3
        sll %l3,7,%l4
        srl %l3,1,%l3
        or  %l3,%l4,%l3
        and %l3,0xff,%l3

        /* disable WIM traps */
        mov %g0,%wim
        nop
        nop 
        nop

        /* point to correct window */
        save

        /* dump registers to stack */
        std %l0, [%sp +  0]
        std %l2, [%sp +  8]
        std %l4, [%sp + 16]
        std %l6, [%sp + 24]
        std %i0, [%sp + 32]
        std %i2, [%sp + 40]
        std %i4, [%sp + 48]
        std %i6, [%sp + 56]

        set 0x80000904, %l7
        mov 2, %l6
        st  %l6, [%l7]
        
        /* back to where we should be */
        restore

        /* set new value of window */
        mov %l3,%wim
        nop
        nop
        nop

        /* go home */
        jmp %l1
        rett %l2

/* a RESTORE instruction caused a trap; thank you http://www.sics.se/~psm/sparcstack.html */
_window_underflow:
        
        
        
        /* rotate WIM on bit LEFT, we have 8 windows -> THIS IS TRUE FOR US */ 
        mov %wim,%l3
        srl %l3,7,%l4
        sll %l3,1,%l3
        or  %l3,%l4,%l3
        and %l3,0xff,%l3

        /* disable WIM traps */
        mov %g0,%wim
        nop
        nop
        nop

        /* point to correct window */
        restore
        restore

        set 0x80000904, %l7
        mov 4, %l6
        st  %l6, [%l7]
        
        /* dump registers to stack */
        ldd [%sp +  0], %l0
        ldd [%sp +  8], %l2
        ldd [%sp + 16], %l4
        ldd [%sp + 24], %l6
        ldd [%sp + 32], %i0
        ldd [%sp + 40], %i2
        ldd [%sp + 48], %i4
        ldd [%sp + 56], %i6

        
        /* back to where we should be */
        save
        save

        /* set new value of window */
        mov %l3,%wim
        nop
        nop
        nop

        /* go home */
        jmp %l1
        rett %l2
        
        